/*:
# **Kapitel 4.6**
## Aufgabe 3 2D-Spielwelt (Teil 5): Florian sammelt Blumen
*/

/**
Die elementare Zelle der Blumenwelt

- author: Peter Brichzin
- version: 1.0
*/
class Zelle: Rechteck
{
    /**
    Platziert eine Zelle
    */
    init (xLinksOben: Int, yLinksOben: Int, farbeNeu: String)
    {
        super.init()
        PositionSetzen(x: xLinksOben, y: yLinksOben)
        GrößeSetzen(breite: 46, höhe: 46)
        FarbeSetzen(farbe: farbeNeu)
    }
}

/**
Blume, die darauf wartet gesammelt zu werden

- author: Peter Brichzin
- version: 1.0
 */
class Blume: Figur
{
    /**
    Der Konstruktor1 erzeugt eine Blume an der Pixel-Position (225/125).
	*/
    override init ()
    {
        super.init()
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        PositionSetzen(x: 225, y: 125)
        GanzNachVornBringen()
    }
    
    /**
    Der Konstruktor2 erzeugt eine Blume in einem Spielfeld mit 10x10 Zellen.
    an der Pixel-Position (225/125).
    - parameters:
        - xNeu:  x-Position der Blume
        - yNeu:  y-Position der Blume
   */
   init (xNeu: Int, yNeu: Int)
    {
        super.init();
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "blau")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "blau")
        GanzNachVornBringen()
       
        if (xNeu<10) && (xNeu>=0) && (yNeu<10) && (yNeu>=0)
        {
            PositionSetzen(x: xNeu*50 + 25, y: yNeu*50 + 25)
        }
    }
//#-editable-code



//#-end-editable-code
}

/**
Legt die Blumenwelt an und die nicht beweglichen Objekte.\
Die Welt besteht aus 10x10 Zellen. Damit die Objekte der Klasse Zelle gut sichtbar sind, wird
zwischen den Zellen ein Abstand von 4 Pixeln gelassen. Mit diesem Rand hat die Welt Zellen der
Größe 50x 50 Pixel.
In der Blumenwelt sind auch mehrere Blumen.

- author: Peter Brichzin
- version: 12.12.19
 */
class Blumenwelt
{
    /**
    Baut das Szenario auf.
    */
    init()
    {
        // Diesen Abschnitt ignorieren, es werden die 10x10 Zellen der Welt erzeugt und positioniert
        for zellenNummerX in 0 ... 9
        {
            for zellenNummerY in 0 ... 9
            {

                Zelle(xLinksOben: 50*zellenNummerX+2, yLinksOben: 50*zellenNummerY+2, farbeNeu: "grün")
            }
        }
        // Abschnittsende

        var nummer: Int //ein Platzhalter für eine Nummer
        nummer = 1 //Startwert 1 für die Nummer
        
        while nummer < 5
        {
            Blume(xNeu: 2*nummer-1, yNeu: nummer)
            Blume(xNeu: nummer, yNeu: 2*nummer+1)
            nummer = nummer + 1 // die Nummer wird um eins erhöht
        }
    }
}
/*:
Florian muss jetzt Blumen in möglichst wenigen Schritten sammeln.\
a\
Ergänze ein Attribut schritte zum Speichern der Anzahl der Schritte von Florian.\
b\
Entwickle das Spiel weiter, indem Blumen bei einer Berührung verschwinden und
in einem Attribut die bereits von Florian gesammelten Blumen gezählt werden.\
c\
Für Schnelle: Ergänze einen Cheat, z.B. einen Sprung von einem Eck ins andere.*/
/**
Die Spielfigur der Blumentwelt.

- author: Peter Brichzin
- version: Version 1.0
 */
class Florian: Figur
{
//#-editable-code
    /**
    Legt die Form und die Startposition fest.
    */
    override init()
    {
        super.init()
        FigurteilFestlegenRechteck(x: -20, y: -15, breite: 40, höhe: 60, farbe: "orange")
        FigurteilFestlegenEllipse(x: -10, y: -50, breite: 20, höhe: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 0, y2: 30, x3: 18, y3: 15, farbe: "gelb")
        PositionSetzen(x: 75, y: 125)
        GanzNachVornBringen()
    }


    /**
    Lässt Florian eine Zelle nach Osten gehen.
    */
    func NachOstenGehen()
    {
        if XPositionGeben() < 450
        {
            PositionSetzen(x: XPositionGeben()+50, y: YPositionGeben())
        }
    }

    /**
    Lässt Florian eine Zelle nach Westen gehen.
    */
    func NachWestenGehen()
    {
        if XPositionGeben() > 50
        {
            PositionSetzen(x: XPositionGeben()-50, y: YPositionGeben())
        }
    }

    /**
    Lässt Florian eine Zelle nach Süden gehen.
    */
    func NachSüdenGehen()
    {
        if YPositionGeben() < 450
        {
            PositionSetzen(x: XPositionGeben(), y: YPositionGeben()+50)
        }
    }

    /**
    Lässt Florian eine Zelle nach Norden gehen.
    */
    func NachNordenGehen()
    {
        if YPositionGeben() > 50
        {
            PositionSetzen(x: XPositionGeben(), y: YPositionGeben()-50)
        }
    }

    /**
    Dreht sich um 90 Grad nach links

    Tipp: Teste vorab (an einem Objekt der Klasse Florian)
    die Methoden Drehen, WinkelGeben, WinkelSetzen der Oberklasse
    */
    func LinksDrehen()
    {
        WinkelSetzen(winkel: WinkelGeben()+90)
    }

    /**
    Dreht sich um 90 Grad nach rechts
    */
    func RechtsDrehen()
    {
        WinkelSetzen(winkel: WinkelGeben()-90)
    }

    /**
    Florian geht einen Schritt in Blickrichtung.
    */
    func Gehen()
    {
        
        if WinkelGeben() == 0
        {
            NachOstenGehen()
        }
        else
        {
            if WinkelGeben() == 90
            {
                NachNordenGehen()
            }
            else
            {
                if WinkelGeben() == 180
                {
                    NachWestenGehen()
                }
                else
                {
                    if WinkelGeben() == 270
                    {
                        NachSüdenGehen()
                    }
                }
            }
        }
    }
    
    /**
    Steuerung der Figur: Links-/Rechtsdrehen über Cursortasten.
	- parameters:
		- taste: die Nummer der gedrückten Taste
    */
    override func SonderTasteGedrückt(taste: Int)
    {
        if taste == 124
        {
            RechtsDrehen()
        }
        else
        {
            if taste == 123
            {
                LinksDrehen()
            }
        }
    }
    
    /**
    Ständige Bewegung, außer Florian ist an der Grenze seiner Welt.
    */
    override func AktionAusführen()
    {
        Gehen()
    }
//#-end-editable-code
}

//#-editable-code
Blumenwelt()
Florian()
//#-end-editable-code
