/*:
# **Kapitel 4.6**
## Aufgabe 6 Krümel und Monster (Teil 4)
*/
/*:
a\
Das Monster soll die Krümel zählen, die es gefressen hat. Ergänze dazu ein
Attribut anzahl in der Klasse MONSTER, das du im Konstruktor auf den Wert 0 setzt
und zu dem du in der Methode *AktionAusführen* nach dem Gehen jedesmal den
Wert 1 addierst, wenn ein Krümelobjekt berührt wird.\
Tipp: Die Anweisung für das Hochzählen lautet anzahl = anzahl + 1\
b\
Erstelle eine Unterklasse GEWONNEN der Klasse TEXT, bei der im Konstruktor der
Text „Du hast das Spiel gewonnen“ gesetzt wird und die den Text an der
linken, oberen Ecke des Spielfelds erscheinen lässt. Erzeuge in der Methode
*AktionAusführen* ein Objekt der Klasse GEWONNEN, sobald das Monster
den zehnten Krümel gefressen hat. Zum einfacheren Erzeugen der Krümel
kannst du die Klasse KRÜMEL um einen Konstruktor erweitern,
der die Position und die Figur fest legt.\
c\
Um das Spiel schwieriger zu gestalten, kannst du die Randüberwachung in *AktionAusführen* so
ändern, dass ähnlich wie in Aufgabe c) der Text „Du hast verloren“ an der rechten oberen
Ecke des Spielfelds erscheint.\
d\
Damit das Monster wirklich „frisst“, muss der Mund des Monsters abwechselnd offen und geschlossen sein.
Ergänze ein Attribut mundIstZu, weches angibt, ob der Mund zu ist (wahr) oder geschlossen (falsch).
Ergänze die Methode *AktionAusführen* so, dass zu Beginn die Monsterfigur abhängig von
mundIstZu offen oder geschlossen dargestellt wird und das Attribut den passenden Wert erhält.
*/
/**
Verwaltet das Monster

- author: Albert Wiedemann
- version: 1.0
 */
class Monster: Figur
{
//#-editable-code
    /**
    Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGelb()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "gelb")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenOrange()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "orange")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenRot()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGrün()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "grün")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
    - parameters:
    	- farbe: die gewünschte Farbe
    */
    func Offen(farbe: String)
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: farbe)
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 50, y2: -10, x3: 50, y3: 10, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit geschlossenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
     */
    func Schließen(farbe: String)
    {
        if farbe == "gelb"
        {
            GeschlossenGelb()
        }
        if farbe == "orange"
        {
            GeschlossenOrange()
        }
        if farbe == "rot"
        {
            GeschlossenRot()
        }
        if farbe == "grün"
        {
            GeschlossenGrün()
        }
    }

    /**
    Stellt das in einer der Farben gelb, orange, rot bzw. grün mit offenem Mund dar.
	- parameters:
    	- farbe: die gewünschte Farbe
    */
    func Öffnen(farbe: String)
    {
        if (farbe == "gelb") || (farbe == "orange") || (farbe == "rot") || (farbe == "grün")
        {
            Offen(farbe: farbe)
        }
    }

    /**
    Die Aktionsmethode für gedrückte Sondertasten.
	- parameters:
        - taste: KeyCode der gedrückten Taste
     */
    override func SonderTasteGedrückt (taste: Int)
    {
        if (taste == 123)
        {
            WinkelSetzen(winkel: 180)
        }
        else
        {
            if (taste == 126)
            {
                WinkelSetzen(winkel: 90)
            }
            else
            {
                if (taste == 124)
                {
                    WinkelSetzen(winkel: 0)
                }
                else
                {
                    if (taste == 125)
                    {
                        WinkelSetzen(winkel: 270)
                    }
                }
            }
        }
    }

    /**
    Das Monster geht maximal bis zum Rand
     */
    override func AktionAusführen()
    {
        if WinkelGeben() == 0
        {
            if XPositionGeben() < 740
            {
                Gehen(länge: 10)
            }
        }
        else
        {
            if WinkelGeben() == 90
            {
                if YPositionGeben() > 30
                {
                    Gehen(länge: 10)
                }
            }
            else
            {
                if WinkelGeben() == 180
                {
                    if XPositionGeben() > 10
                    {
                        Gehen(länge: 10)
                    }
                }
                else
                {
                    if WinkelGeben() == 270
                    {
                        if YPositionGeben() < 500
                        {
                            Gehen(länge: 10)
                        }
                    }
                }
            }
        }
    }
//#-end-editable-code
}

/**
Verwaltet einen Krümel

- author: Albert Wiedemann
- version: 1.0
 */
class Krümel: Figur
{
//#-editable-code
    /**
    Stellt den orangen Krümel dar.
    */
    func FigurFestlegen()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -5, y: -5, breite: 10, höhe: 10, farbe: "orange")
    }
    
    /**
    Der Krümel verschwindet bei Berührung
    */
    override func AktionAusführen()
    {
        if Berührt()
        {
            Entfernen()
        }
    }
//#-end-editable-code
}
//#-editable-code

//#-end-editable-code



//#-editable-code
let monster = Monster()
monster.Öffnen(farbe: "gelb")

let k1 = Krümel()
k1.FigurFestlegen()
k1.PositionSetzen(x: 200, y: 300)
let k2 = Krümel()
k2.FigurFestlegen()
k2.PositionSetzen(x: 300, y: 300)
let k3 = Krümel()
k3.FigurFestlegen()
k3.PositionSetzen(x: 400, y: 200)

//#-end-editable-code

